#include "dfplayer.h"
uint8_t DFP_Buffer[10] = {0x7E, 0xFF, 0x06, 0x00, 0, 0x00, 0x00, 0, 0, 0xEF};
uint8_t DFP_Source_Init_Online, DFP_Source_In_Out, DFP_Module_Error;
uint8_t DFP_Finish_Playback;

uint16_t DFP_CheckSum(void)
{
	uint16_t Sum = 0;
	for(uint8_t i=1; i<7; i++){
		Sum += DFP_Buffer[i];
	}
	return (0-Sum);
}

void DFP_Send(void)
{
  	uint16_t CRC = DFP_CheckSum();
  	DFP_Buffer[7] = (uint8_t)(CRC >> 8);
	DFP_Buffer[8] = (uint8_t)CRC;
  	for(uint8_t i=0; i<10; i++){
		UART1->DR = DFP_Buffer[i];
    	while(!(UART1->SR & 0x40)); //TC
  	}
}
/*
Ham gui lenh dieu khien DFP_SendCommand(CMD, DATA);
VD: DFP_SendCommand(DFP_CMD_NEXT, 0); //Next bai hat
*/
void DFP_SendCommand(uint8_t Cmd, uint16_t Data)
{
  	DFP_Buffer[3] = Cmd;
	DFP_Buffer[4] = 0x00; //FB none
	DFP_Buffer[5] = (uint8_t)(Data >> 8);
	DFP_Buffer[6] = (uint8_t)Data;
	DFP_Send();
}

void DFP_PlayTrack(uint16_t Track) //1-2999 Track
{
	//if(Track > 2999)return;
  	DFP_SendCommand(DFP_CMD_TRACK, Track);
}

void DFP_PlayFile(uint8_t Folder, uint8_t File) // ../99/255.mp3
{
  	//if(Folder > 99)return;
  	DFP_SendCommand(DFP_CMD_FOLDER, ((uint16_t)Folder << 8 | File));
}

void DFP_Volume(uint8_t Level) //0-30 VOL
{
  	//if(Level > 30)return;
	DFP_SendCommand(DFP_CMD_VOLUME, Level);
}

/*void DFP_Repeat(uint8_t Repeat) // ALL/FOLDER/SINGLE/RANDOM
{
  	if(Repeat > 3)return;
	DFP_SendCommand(DFP_CMD_REPEAT, Repeat);
}

void DFP_Source(uint8_t Source) // USB/SD/AUX/SLEEP/FLASH
{
  	if(Source > 4)return;
	DFP_SendCommand(DFP_CMD_SOURCE, Source);
}

void DFP_EQ(uint8_t EQ) // NORMAL/POP/ROCK/JAZZ/CLASSIC/BASE
{
  	if(EQ > 5)return;
	DFP_SendCommand(DFP_CMD_EQ, EQ);
}*/

void DFP_Process(uint8_t *Buffer) //UART RX IDLE
{
  	if(Buffer[0] != 0x7E)return; //Check Byte Start
	switch(Buffer[3])
	{
	  	case 0x3A: DFP_Source_In_Out = Buffer[6]; break; //Push in
		case 0x3B: DFP_Source_In_Out = Buffer[6]+2; break; //Pull out
	  	case 0x3C: DFP_Finish_Playback = 1; break; //USB Finish Playback Track
		case 0x3D: DFP_Finish_Playback = 1; break; //SD Finish Playback Track
		case 0x3E: DFP_Finish_Playback = 1; break; //FLASH Finish Playback Track
		case 0x3F: DFP_Source_Init_Online = Buffer[6]; break; //Source online Power on
		case 0x40: DFP_Module_Error = Buffer[6]+1; break; //Busy & Error
        default: break;
	}
	Buffer[0] = 0;
}

