#ifndef __DFPLAYER_H
#define __DFPLAYER_H
#include "main.h"
#define uint32_t 	unsigned long
#define uint16_t 	unsigned int
#define uint8_t 	unsigned char
//Cac lenh chinh DFP_SendCommand( CMD, DATA(DH+DL) );
#define DFP_CMD_NEXT		0x01 //Tien bai hat
#define DFP_CMD_PREV		0x02 //Lui bai hat
#define DFP_CMD_TRACK		0x03 //Phat chon bai 1-2999
#define DFP_CMD_INCVOL		0x04 //Tang am luong
#define DFP_CMD_DECVOL		0x05 //Giam am luong
#define DFP_CMD_VOLUME		0x06 //Thiet lap am luong 0-30
#define DFP_CMD_EQ			0x07 //Thiet lap EQ
#define DFP_CMD_REPEAT		0x08 //Thiet lap phat lap lai
#define DFP_CMD_SOURCE		0x09 //Chon nguon phat nhac
#define DFP_CMD_SLEEP		0x0A //Che do ngu
#define DFP_CMD_NORMAL		0x0B //Che do binh thuong
#define DFP_CMD_RESET		0x0C //Reset module
#define DFP_CMD_PLAY		0x0D //Lenh Play
#define DFP_CMD_PAUSE		0x0E //Lenh pause
#define DFP_CMD_FOLDER		0x0F //Phat chon bai theo thu muc file
#define DFP_CMD_VOLADJ		0x10 //Bo dieu chinh am luong, DH=1:ON; DH=0:MUTE; DL:0-31
#define DFP_CMD_REPLAY		0x11 //DL=1 Phat lai hoac DL=0 dung phat lai (STOP)
//Che do phat lap lai
#define DFP_REPEAT_ALL		0
#define DFP_REPEAT_FOLDER	1
#define DFP_REPEAT_SINGLE	2
#define DFP_REPEAT_RANDOM	3
//Chon nguon phat nhac
#define DFP_SOURCE_USB		0
#define DFP_SOURCE_SDCARD	1
#define DFP_SOURCE_AUX		2
#define DFP_SOURCE_SLEEP	3
#define DFP_SOURCE_FLASH	4
//Dieu chinh am sac EQ
#define DFP_EQ_NORMAL		0
#define DFP_EQ_POP			1
#define DFP_EQ_ROCK			2
#define DFP_EQ_JAZZ			3
#define DFP_EQ_CLASSIC		4
#define DFP_EQ_BASE			5
//Trang thai nguon phat nhac khi khoi dong
#define DFP_SOURCE_USB_ONLINE		1
#define DFP_SOURCE_SD_ONLINE		2
#define DFP_SOURCE_AUX_ONLINE		4
#define DFP_SOURCE_FLASH_ONLINE		8
#define DFP_SOURCE_USB_SD_ONLINE	3
//Trang thai cam vao va rut ra USB/SD
#define DFP_SOURCE_PUSH_IN_USB		1
#define DFP_SOURCE_PUSH_IN_SD		2
#define DFP_SOURCE_PULL_OUT_USB		3
#define DFP_SOURCE_PULL_OUT_SD		4
//Thong bao loi
#define DFP_MODULE_ERROR_BUSY		1
#define DFP_MODULE_ERROR_FRAME		2
#define DFP_MODULE_ERROR_CRC		3
//Ham chuc nang
void DFP_SendCommand(uint8_t Cmd, uint16_t Data);
void DFP_PlayTrack(uint16_t Track);
void DFP_PlayFile(uint8_t Folder, uint8_t File);
void DFP_Volume(uint8_t Level);
void DFP_Source(uint8_t Source);
void DFP_Repeat(uint8_t Repeat);
void DFP_EQ(uint8_t EQ);
void DFP_Process(uint8_t *Buffer);
//
#endif
